<template>
    <div class="row">
        <div class="col-lg-8 m-auto">
            <card :title="$t('login')">
                <form @submit.prevent="login" @keydown="form.onKeydown($event)">
                    <!-- Email -->
                    <div class="form-group row">
                        <label class="col-md-3 col-form-label text-md-right">{{ $t('email') }}</label>
                        <div class="col-md-7">
                            <input v-model="form.email" :class="{ 'is-invalid': form.errors.has('email') }"
                                   class="form-control" type="email" name="email">
                            <has-error :form="form" field="email"/>
                        </div>
                    </div>

                    <!-- Password -->
                    <div class="form-group row">
                        <label class="col-md-3 col-form-label text-md-right">{{ $t('password') }}</label>
                        <div class="col-md-7">
                            <input v-model="form.password" :class="{ 'is-invalid': form.errors.has('password') }"
                                   class="form-control" type="password" name="password">
                            <has-error :form="form" field="password"/>
                        </div>
                    </div>

                    <!-- Remember Me -->
                    <div class="form-group row">
                        <div class="col-md-3"/>
                        <div class="col-md-7 d-flex">
                            <checkbox v-model="form.remember" name="remember">
                                {{ $t('remember_me') }}
                            </checkbox>

                            <!--<router-link :to="{ name: 'password.request' }" class="small ml-auto my-auto">-->
                                <!--{{ $t('forgot_password') }}-->
                            <!--</router-link>-->
                        </div>
                    </div>

                    <div class="form-group row">
                        <div class="col-md-7 offset-md-3 d-flex">
                            <!-- Submit Button -->
                            <v-button :loading="form.busy">
                                Login
                            </v-button>

                            <!-- GitHub Login Button -->
                            <login-with-github/>
                        </div>
                    </div>
                </form>
            </card>
        </div>
    </div>
</template>

<script>
    import Form from 'vform'
    import Cookies from 'js-cookie'
    import LoginWithGithub from '~/components/LoginWithGithub'

    export default {
        components: {
            LoginWithGithub
        },

        middleware: 'guest',

        metaInfo() {
            return {title: this.$t('login')}
        },

        data: () => ({
            form: new Form({
                email: '',
                password: '',
                remember: false
            })
        }),

        methods: {
            async login() {
                // Submit the form.
                await this.form.post('/login')

                // Fetch the user.
                await this.$store.dispatch('auth/fetchUser')

                // Redirect home.
                this.redirect()
            },

            redirect() {
                const intendedUrl = Cookies.get('intended_url')

                if (intendedUrl) {
                    Cookies.remove('intended_url')
                    this.$router.push({path: intendedUrl})
                } else {
                    this.$router.push({name: 'home'})
                }
            }
        }
    }
</script>
